import * as admin from 'firebase-admin';
import type { SupportedRegion } from 'firebase-functions/v2/options';
import type { FirebaseFunctions } from '../firebase';
import { type FirebaseOptions } from 'firebase/app';
import { type Firestore as FirestoreInstance } from 'firebase/firestore';
import { FirebaseAuthenticator } from './FirebaseAuthenticator';
import { FirebaseFunctionsCaller } from './FirebaseFunctionsCaller';
export declare class FirebaseApp<Functions extends FirebaseFunctions> {
    private readonly options;
    private readonly functionsInstance;
    private readonly authInstance;
    readonly firestore: FirestoreInstance;
    constructor(options: FirebaseApp.Options);
    get functions(): FirebaseFunctionsCaller<Functions>;
    get auth(): FirebaseAuthenticator;
}
export declare namespace FirebaseApp {
    interface Options {
        macKey: Uint8Array;
        firebaseOptions: FirebaseOptions & admin.ServiceAccount;
        region: SupportedRegion;
        emulatorPorts: {
            functions: number;
            auth: number;
            firestore: number;
        };
    }
}
